
/* ###--------------------------------------------------------------### */
/* 									*/
/* file		: pat_getusage.c					*/
/* date		: Aug 31 1993						*/
/* version	: v104							*/
/* authors	: Pirouz BAZARGAN SABET					*/
/* content	: high level function					*/
/*									*/
/* ###--------------------------------------------------------------### */

#include <stdio.h>
#include PAT_H
#include PHL_H

void pat_getusage (ptseq, ptuse)

struct paseq *ptseq;
struct pause *ptuse;

  {
  struct paseq  *seq_pnt;
  struct paiol  *iol_pnt;
  struct pagrp  *grp_pnt;
  struct papat  *pat_pnt;
  struct paevt  *evt_pnt;
  struct paini  *ini_pnt;
  struct pacom  *com_pnt;

	/* ###------------------------------------------------------### */
	/*    count pattern sequences					*/
	/* ###------------------------------------------------------### */

  seq_pnt = ptseq;
  while (seq_pnt != NULL)
    {

    if (seq_pnt->SUBSEQ == 1)
      {
      ptuse->PASEQ++;

      if (seq_pnt->NAME != NULL)
        ptuse->CHARACTER += strlen (seq_pnt->NAME);

	/* ###------------------------------------------------------### */
	/*    inside each sequence count arraies of input-outputs	*/
	/* ###------------------------------------------------------### */

      grp_pnt = seq_pnt->PAGRP;
      while (grp_pnt != NULL)
        {
        ptuse->PAGRP++;

        if (grp_pnt->NAME != NULL)
          ptuse->CHARACTER += strlen (grp_pnt->NAME);

        grp_pnt = grp_pnt->NEXT;
        }

	/* ###------------------------------------------------------### */
	/*    inside each sequence count input-outputs			*/
	/* ###------------------------------------------------------### */

      iol_pnt = seq_pnt->PAIOL;
      while (iol_pnt != NULL)
        {
        ptuse->PAIOL++;

        if (iol_pnt->NAME != NULL)
          ptuse->CHARACTER += strlen (iol_pnt->NAME);

        iol_pnt = iol_pnt->NEXT;
        }

	/* ###------------------------------------------------------### */
	/*    inside each sequence count (declaration) comments		*/
	/* ###------------------------------------------------------### */

      com_pnt = seq_pnt->DECCOM;
      while (com_pnt != NULL)
        {
        ptuse->PACOM++;

        if (com_pnt->TEXT != NULL)
          ptuse->CHARACTER += strlen (com_pnt->TEXT);

        com_pnt = com_pnt->NEXT;
        }

      }

	/* ###------------------------------------------------------### */
	/*    inside each sequence count (description) comments		*/
	/* ###------------------------------------------------------### */

    com_pnt = seq_pnt->CURCOM;
    while (com_pnt != NULL)
      {
      ptuse->PACOM++;

      if (com_pnt->TEXT != NULL)
        ptuse->CHARACTER += strlen (com_pnt->TEXT);

      com_pnt = com_pnt->NEXT;
      }

	/* ###------------------------------------------------------### */
	/*    inside each sequence count patterns			*/
	/* ###------------------------------------------------------### */

    pat_pnt = seq_pnt->CURPAT;
    while ((pat_pnt != NULL) && (pat_pnt != seq_pnt->NXTPAT))
      {
      ptuse->PAPAT++;

	/* ###------------------------------------------------------### */
	/*    for each pattern count events				*/
	/* ###------------------------------------------------------### */

      evt_pnt = pat_pnt->PAEVT;
      while (evt_pnt != NULL)
        {
        ptuse->PAEVT++;
        evt_pnt = evt_pnt->NEXT;
        }

	/* ###------------------------------------------------------### */
	/*    for each pattern count initializations			*/
	/* ###------------------------------------------------------### */

      ini_pnt = pat_pnt->PAINI;
      while (ini_pnt != NULL)
        {
        ptuse->PAINI++;

        if (ini_pnt->NAME != NULL)
          ptuse->CHARACTER += strlen (ini_pnt->NAME);

        ini_pnt = ini_pnt->NEXT;
        }

      pat_pnt = pat_pnt->NEXT;
      }

    seq_pnt = seq_pnt->NEXT;
    }

  }
